diff --git a/kernel/wg_tcp_debug.h b/kernel/wg_tcp_debug.h
new file mode 100644
index 0000000000000000000000000000000000000000..82a32ed5fa24ad1fb97ef2a92e428233e620c8b1
--- /dev/null
+++ b/kernel/wg_tcp_debug.h
@@ -0,0 +1,90 @@
+// SPDX-License-Identifier: GPL-2.0
+/*
+ * Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
+ */
+/*
+ * WireGuard TCP Debug Macros
+ *
+ * Two independent levels, enabled via compiler flags:
+ *
+ *   -DWG_TCP_VERBOSE   Very verbose: function enter/exit traces, parameter
+ *                       dumps, packet header parsing. Extremely noisy.
+ *
+ *   -DWG_TCP_DIAG      TCP performance diagnostics: per-packet socket state
+ *                       dumps (cwnd, rtt, retrans, etc). Useful for debugging
+ *                       throughput and congestion issues.
+ *
+ * Build examples (add to Makefile ccflags-y or command line):
+ *   make ... EXTRA_CFLAGS="-DWG_TCP_VERBOSE -DWG_TCP_DIAG"   # everything
+ *   make ... EXTRA_CFLAGS="-DWG_TCP_DIAG"                     # perf diag only
+ *   make ...                                                    # no debug
+ *
+ * Error messages (KERN_ERR / pr_err) are always compiled in.
+ */
+
+#ifndef _WG_TCP_DEBUG_H
+#define _WG_TCP_DEBUG_H
+
+#include <linux/icmp.h>
+#include <linux/atomic.h>
+#include <linux/types.h>
+
+#ifdef WG_TCP_VERBOSE
+#define wg_dbg(fmt, ...)	printk(KERN_INFO fmt, ##__VA_ARGS__)
+#else
+#define wg_dbg(fmt, ...)	do {} while (0)
+#endif
+
+#ifdef WG_TCP_DIAG
+#define wg_diag(fmt, ...)	pr_info(fmt, ##__VA_ARGS__)
+#define WG_TCP_DIAG_ENABLED	1
+#else
+#define wg_diag(fmt, ...)	do {} while (0)
+#define WG_TCP_DIAG_ENABLED	0
+#endif
+
+struct sk_buff;
+struct crypt_queue;
+struct sk_buff_head;
+struct sock;
+struct socket;
+struct wg_device;
+struct wg_peer;
+
+void debug_skb(const struct sk_buff *askb);
+void debug_wireguard_packet(const unsigned char *data,
+                                   size_t payload_len);
+void debug_wireguard_skb(const struct sk_buff *skb);
+void debug_wireguard_tcp_mtu(struct sk_buff *skb, const char *location);
+
+void decode_icmp_echo(const struct icmphdr *icmp_header);
+void decode_icmp_dest_unreachable(const struct icmphdr *icmp_header);
+void decode_icmp_time_exceeded(const struct icmphdr *icmp_header);
+void decode_icmp_other(const struct icmphdr *icmp_header);
+void decode_and_print_packet(const struct sk_buff *skb, const char *prefix);
+
+void print_wg_peer(struct wg_peer *peer);
+void print_crypt_queue(const char *label, struct crypt_queue *queue);
+void print_wg_device(struct wg_device *device);
+void print_skbuff_head_info(const char *label, struct sk_buff_head *queue);
+void print_tcp_socket_info(struct socket *sock, const char *label);
+void print_peer_socket_info(struct wg_peer *peer);
+
+#ifdef WG_TCP_DIAG
+extern atomic64_t wg_tcp_stats_tx_bytes;
+extern atomic64_t wg_tcp_stats_rx_bytes;
+extern atomic64_t wg_tcp_stats_tx_packets;
+extern atomic64_t wg_tcp_stats_rx_packets;
+extern atomic64_t wg_tcp_stats_tx_eagain;
+extern atomic64_t wg_tcp_stats_tx_errors;
+extern atomic64_t wg_tcp_stats_rx_errors;
+extern atomic64_t wg_tcp_stats_short_writes;
+extern atomic64_t wg_tcp_stats_retransmits;
+
+void wg_tcp_diag_dump_sock(struct sock *sk, const char *where,
+			   int result, unsigned int queued);
+void wg_tcp_diag_pressure(struct sock *sk, u64 peer_id);
+void wg_tcp_diag_aggregate(void);
+#endif
+
+#endif /* _WG_TCP_DEBUG_H */
diff --git a/kernel/wireguard_tcp_uapi.h b/kernel/wireguard_tcp_uapi.h
new file mode 100644
index 0000000000000000000000000000000000000000..72bafb4772dae1caac64ad31ec973646230a41a8
--- /dev/null
+++ b/kernel/wireguard_tcp_uapi.h
@@ -0,0 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+
+#ifndef _WG_TCP_UAPI_H
+#define _WG_TCP_UAPI_H
+
+#include "../include/uapi/linux/wireguard.h"
+
+#endif
diff --git a/tools/Makefile b/tools/Makefile
index c37865bfa5b301ebdb6089bee6c73eb41b1b3eb2..5b68b32d3111ce04ea653599cfb5a1c0ddac156f 100644
--- a/tools/Makefile
+++ b/tools/Makefile
@@ -39,7 +39,7 @@ PLATFORM ?= $(shell uname -s | tr '[:upper:]' '[:lower:]')
 
 CFLAGS ?= -O3
 ifneq ($(wildcard uapi/$(PLATFORM)/.),)
-CFLAGS += -isystem uapi/$(PLATFORM)
+CFLAGS += -Iuapi/$(PLATFORM)
 endif
 CFLAGS += -std=gnu99 -D_GNU_SOURCE
 CFLAGS += -Wall -Wextra
diff --git a/tools/config.c b/tools/config.c
index 0e145d4cd76c71487b51043bf5898523d390739c..866035cefd762723427ca68dfd6c6d8e254eddf0 100644
--- a/tools/config.c
+++ b/tools/config.c
@@ -305,6 +305,19 @@ err:
 	return false;
 }
 
+static inline bool parse_transport(uint8_t *transport, const char *value)
+{
+	if (!strcasecmp(value, "udp"))
+		*transport = WG_TRANSPORT_UDP;
+	else if (!strcasecmp(value, "tcp"))
+		*transport = WG_TRANSPORT_TCP;
+	else {
+		fprintf(stderr, "Transport is neither udp nor tcp: `%s'\n", value);
+		return false;
+	}
+	return true;
+}
+
 static bool validate_netmask(struct wgallowedip *allowedip)
 {
 	uint32_t *ip;
@@ -473,6 +486,10 @@ static bool process_line(struct config_ctx *ctx, const char *line)
 			ret = parse_key(ctx->device->private_key, value);
 			if (ret)
 				ctx->device->flags |= WGDEVICE_HAS_PRIVATE_KEY;
+		} else if (key_match("Transport") || key_match("TransportMode")) {
+			ret = parse_transport(&ctx->device->transport, value);
+			if (ret)
+				ctx->device->flags |= WGDEVICE_HAS_TRANSPORT;
 		} else
 			goto error;
 	} else if (ctx->is_peer_section) {
@@ -612,6 +629,12 @@ struct wgdevice *config_read_cmd(const char *argv[], int argc)
 			device->flags |= WGDEVICE_HAS_PRIVATE_KEY;
 			argv += 2;
 			argc -= 2;
+		} else if (!strcmp(argv[0], "transport") && argc >= 2 && !peer) {
+			if (!parse_transport(&device->transport, argv[1]))
+				goto error;
+			device->flags |= WGDEVICE_HAS_TRANSPORT;
+			argv += 2;
+			argc -= 2;
 		} else if (!strcmp(argv[0], "peer") && argc >= 2) {
 			struct wgpeer *new_peer = calloc(1, sizeof(*new_peer));
 
diff --git a/tools/containers.h b/tools/containers.h
index 30a673918517feeb28dae64eeec37c5d5ae0ee55..140283f0b02f32e462f4f034486e2700425f850f 100644
--- a/tools/containers.h
+++ b/tools/containers.h
@@ -22,6 +22,11 @@
 #define WG_KEY_LEN 32
 #endif
 
+#ifndef WG_TRANSPORT_UDP
+#define WG_TRANSPORT_UDP 0
+#define WG_TRANSPORT_TCP 1
+#endif
+
 /* Cross platform __kernel_timespec */
 struct timespec64 {
 	int64_t tv_sec;
@@ -76,7 +81,8 @@ enum {
 	WGDEVICE_HAS_PRIVATE_KEY = 1U << 1,
 	WGDEVICE_HAS_PUBLIC_KEY = 1U << 2,
 	WGDEVICE_HAS_LISTEN_PORT = 1U << 3,
-	WGDEVICE_HAS_FWMARK = 1U << 4
+	WGDEVICE_HAS_FWMARK = 1U << 4,
+	WGDEVICE_HAS_TRANSPORT = 1U << 5
 };
 
 struct wgdevice {
@@ -90,6 +96,7 @@ struct wgdevice {
 
 	uint32_t fwmark;
 	uint16_t listen_port;
+	uint8_t transport;
 
 	struct wgpeer *first_peer, *last_peer;
 };
diff --git a/tools/ipc-linux.h b/tools/ipc-linux.h
index 9f78c6742f74a39a81174f4fc8d01e74813ee733..45f62e78628e7801d80608d729b0e700ffca3960 100644
--- a/tools/ipc-linux.h
+++ b/tools/ipc-linux.h
@@ -139,15 +139,33 @@ cleanup:
 	return ret;
 }
 
+static int kernel_get_device(struct wgdevice **device, const char *iface);
+
 static int kernel_set_device(struct wgdevice *dev)
 {
 	int ret = 0;
+	struct wgdevice *current = NULL;
 	struct wgpeer *peer = NULL;
 	struct wgallowedip *allowedip = NULL;
 	struct nlattr *peers_nest, *peer_nest, *allowedips_nest, *allowedip_nest;
 	struct nlmsghdr *nlh;
 	struct mnlg_socket *nlg;
 
+	if (dev->flags & WGDEVICE_HAS_TRANSPORT) {
+		ret = kernel_get_device(&current, dev->name);
+		if (ret < 0)
+			return ret;
+		if (!(current->flags & WGDEVICE_HAS_TRANSPORT)) {
+			free_wgdevice(current);
+			if (dev->transport == WG_TRANSPORT_TCP) {
+				errno = EOPNOTSUPP;
+				return -EOPNOTSUPP;
+			}
+			dev->flags &= ~WGDEVICE_HAS_TRANSPORT;
+		} else
+			free_wgdevice(current);
+	}
+
 	nlg = mnlg_socket_open(WG_GENL_NAME, WG_GENL_VERSION);
 	if (!nlg)
 		return -errno;
@@ -165,6 +183,8 @@ again:
 			mnl_attr_put_u16(nlh, WGDEVICE_A_LISTEN_PORT, dev->listen_port);
 		if (dev->flags & WGDEVICE_HAS_FWMARK)
 			mnl_attr_put_u32(nlh, WGDEVICE_A_FWMARK, dev->fwmark);
+		if (dev->flags & WGDEVICE_HAS_TRANSPORT)
+			mnl_attr_put_u8(nlh, WGDEVICE_A_TRANSPORT, dev->transport);
 		if (dev->flags & WGDEVICE_REPLACE_PEERS)
 			flags |= WGDEVICE_F_REPLACE_PEERS;
 		if (flags)
@@ -441,6 +461,14 @@ static int parse_device(const struct nlattr *attr, void *data)
 		if (!mnl_attr_validate(attr, MNL_TYPE_U32))
 			device->fwmark = mnl_attr_get_u32(attr);
 		break;
+	case WGDEVICE_A_TRANSPORT:
+		if (!mnl_attr_validate(attr, MNL_TYPE_U8)) {
+			device->transport = mnl_attr_get_u8(attr);
+			if (device->transport > WG_TRANSPORT_TCP)
+				return MNL_CB_ERROR;
+			device->flags |= WGDEVICE_HAS_TRANSPORT;
+		}
+		break;
 	case WGDEVICE_A_PEERS:
 		return mnl_attr_parse_nested(attr, parse_peers, device);
 	}
diff --git a/tools/ipc.c b/tools/ipc.c
index 945c9363a4afb415516f8b67cd08c12993ef72a7..b1e01177b11db971f9f1c3c6a7df861c4ae06a0c 100644
--- a/tools/ipc.c
+++ b/tools/ipc.c
@@ -86,13 +86,30 @@ int ipc_get_device(struct wgdevice **dev, const char *iface)
 #endif
 }
 
+static int prepare_userspace_transport(struct wgdevice *dev)
+{
+	if (!(dev->flags & WGDEVICE_HAS_TRANSPORT))
+		return 0;
+	if (dev->transport == WG_TRANSPORT_TCP) {
+		errno = EOPNOTSUPP;
+		return -EOPNOTSUPP;
+	}
+	dev->flags &= ~WGDEVICE_HAS_TRANSPORT;
+	return 0;
+}
+
 int ipc_set_device(struct wgdevice *dev)
 {
 #ifdef IPC_SUPPORTS_KERNEL_INTERFACE
-	if (userspace_has_wireguard_interface(dev->name))
+	if (userspace_has_wireguard_interface(dev->name)) {
+		if (prepare_userspace_transport(dev) < 0)
+			return -EOPNOTSUPP;
 		return userspace_set_device(dev);
+	}
 	return kernel_set_device(dev);
 #else
+	if (prepare_userspace_transport(dev) < 0)
+		return -EOPNOTSUPP;
 	return userspace_set_device(dev);
 #endif
 }
diff --git a/tools/netlink.h b/tools/netlink.h
index ca11bae47b11f0787e25bb815edd592d1c78bafc..7806772b02f0214204e29507c29166c4746cfff5 100644
--- a/tools/netlink.h
+++ b/tools/netlink.h
@@ -318,6 +318,11 @@ static void mnl_attr_put(struct nlmsghdr *nlh, uint16_t type, size_t len,
 		memset(mnl_attr_get_payload(attr) + len, 0, pad);
 }
 
+static void mnl_attr_put_u8(struct nlmsghdr *nlh, uint16_t type, uint8_t data)
+{
+	mnl_attr_put(nlh, type, sizeof(data), &data);
+}
+
 static void mnl_attr_put_u16(struct nlmsghdr *nlh, uint16_t type, uint16_t data)
 {
 	mnl_attr_put(nlh, type, sizeof(uint16_t), &data);
diff --git a/tools/set.c b/tools/set.c
index 63803d6825168e9d7bc5ca451258880b0e4ef7c2..918d35dbbb92e8c5419f0cf0107d965f030fcdfe 100644
--- a/tools/set.c
+++ b/tools/set.c
@@ -18,7 +18,7 @@ int set_main(int argc, const char *argv[])
 	int ret = 1;
 
 	if (argc < 3) {
-		fprintf(stderr, "Usage: %s %s <interface> [listen-port <port>] [fwmark <mark>] [private-key <file path>] [peer <base64 public key> [remove] [preshared-key <file path>] [endpoint <ip>:<port>] [persistent-keepalive <interval seconds>] [allowed-ips [+|-]<ip1>/<cidr1>[,[+|-]<ip2>/<cidr2>]...] ]...\n", PROG_NAME, argv[0]);
+		fprintf(stderr, "Usage: %s %s <interface> [listen-port <port>] [fwmark <mark>] [private-key <file path>] [transport <udp|tcp>] [peer <base64 public key> [remove] [preshared-key <file path>] [endpoint <ip>:<port>] [persistent-keepalive <interval seconds>] [allowed-ips [+|-]<ip1>/<cidr1>[,[+|-]<ip2>/<cidr2>]...] ]...\n", PROG_NAME, argv[0]);
 		return 1;
 	}
 
diff --git a/tools/show.c b/tools/show.c
index 0f6eab891cf96e08cf35e1ea851c156e68f888d7..bb84fa1589b5dec3a08fc144850fb104ba9f73fb 100644
--- a/tools/show.c
+++ b/tools/show.c
@@ -126,6 +126,15 @@ static char *endpoint(const struct sockaddr *addr)
 	return buf;
 }
 
+static const char *transport(uint8_t value)
+{
+	if (value == WG_TRANSPORT_TCP)
+		return "tcp";
+	if (value == WG_TRANSPORT_UDP)
+		return "udp";
+	return "unknown";
+}
+
 static size_t pretty_time(char *buf, const size_t len, unsigned long long left)
 {
 	size_t offset = 0;
@@ -202,7 +211,7 @@ static char *bytes(uint64_t b)
 static const char *COMMAND_NAME;
 static void show_usage(void)
 {
-	fprintf(stderr, "Usage: %s %s { <interface> | all | interfaces } [public-key | private-key | listen-port | fwmark | peers | preshared-keys | endpoints | allowed-ips | latest-handshakes | transfer | persistent-keepalive | dump]\n", PROG_NAME, COMMAND_NAME);
+	fprintf(stderr, "Usage: %s %s { <interface> | all | interfaces } [public-key | private-key | listen-port | fwmark | transport | peers | preshared-keys | endpoints | allowed-ips | latest-handshakes | transfer | persistent-keepalive | dump]\n", PROG_NAME, COMMAND_NAME);
 }
 
 static void pretty_print(struct wgdevice *device)
@@ -220,6 +229,8 @@ static void pretty_print(struct wgdevice *device)
 		terminal_printf("  " TERMINAL_BOLD "listening port" TERMINAL_RESET ": %u\n", device->listen_port);
 	if (device->fwmark)
 		terminal_printf("  " TERMINAL_BOLD "fwmark" TERMINAL_RESET ": 0x%x\n", device->fwmark);
+	if (device->transport == WG_TRANSPORT_TCP)
+		terminal_printf("  " TERMINAL_BOLD "transport" TERMINAL_RESET ": tcp\n");
 	if (device->first_peer) {
 		sort_peers(device);
 		terminal_printf("\n");
@@ -311,6 +322,10 @@ static bool ugly_print(struct wgdevice *device, const char *param, bool with_int
 			printf("0x%x\n", device->fwmark);
 		else
 			printf("off\n");
+	} else if (!strcmp(param, "transport")) {
+		if (with_interface)
+			printf("%s\t", device->name);
+		printf("%s\n", transport(device->transport));
 	} else if (!strcmp(param, "endpoints")) {
 		for_each_wgpeer(device, peer) {
 			if (with_interface)
diff --git a/tools/showconf.c b/tools/showconf.c
index be02d7ad306ff6c50dabb09d93ea5431a22fdcae..634f16ef0659361f7300c12a383bdd2c81d9c725 100644
--- a/tools/showconf.c
+++ b/tools/showconf.c
@@ -46,6 +46,8 @@ int showconf_main(int argc, const char *argv[])
 		key_to_base64(base64, device->private_key);
 		printf("PrivateKey = %s\n", base64);
 	}
+	if (device->flags & WGDEVICE_HAS_TRANSPORT)
+		printf("Transport = %s\n", device->transport == WG_TRANSPORT_TCP ? "tcp" : "udp");
 	printf("\n");
 	for_each_wgpeer(device, peer) {
 		key_to_base64(base64, peer->public_key);
diff --git a/tools/uapi/linux/linux/wireguard.h b/tools/uapi/linux/linux/wireguard.h
index c285d66a4bd81903659998c01a3d7fcbc788079b..b01cb746cef0a0b91b80bc38179e9e7f30e0b1fe 100644
--- a/tools/uapi/linux/linux/wireguard.h
+++ b/tools/uapi/linux/linux/wireguard.h
@@ -29,6 +29,7 @@
  *    WGDEVICE_A_PUBLIC_KEY: NLA_EXACT_LEN, len WG_KEY_LEN
  *    WGDEVICE_A_LISTEN_PORT: NLA_U16
  *    WGDEVICE_A_FWMARK: NLA_U32
+ *    WGDEVICE_A_TRANSPORT: NLA_U8, WG_TRANSPORT_UDP or WG_TRANSPORT_TCP
  *    WGDEVICE_A_PEERS: NLA_NESTED
  *        0: NLA_NESTED
  *            WGPEER_A_PUBLIC_KEY: NLA_EXACT_LEN, len WG_KEY_LEN
@@ -83,6 +84,8 @@
  *    WGDEVICE_A_PRIVATE_KEY: len WG_KEY_LEN, all zeros to remove
  *    WGDEVICE_A_LISTEN_PORT: NLA_U16, 0 to choose randomly
  *    WGDEVICE_A_FWMARK: NLA_U32, 0 to disable
+ *    WGDEVICE_A_TRANSPORT: NLA_U8, WG_TRANSPORT_UDP or WG_TRANSPORT_TCP;
+ *                          omission preserves the current transport
  *    WGDEVICE_A_PEERS: NLA_NESTED
  *        0: NLA_NESTED
  *            WGPEER_A_PUBLIC_KEY: len WG_KEY_LEN
@@ -140,6 +143,9 @@
 
 #define WG_KEY_LEN 32
 
+#define WG_TRANSPORT_UDP 0
+#define WG_TRANSPORT_TCP 1
+
 enum wg_cmd {
 	WG_CMD_GET_DEVICE,
 	WG_CMD_SET_DEVICE,
@@ -161,6 +167,7 @@ enum wgdevice_attribute {
 	WGDEVICE_A_LISTEN_PORT,
 	WGDEVICE_A_FWMARK,
 	WGDEVICE_A_PEERS,
+	WGDEVICE_A_TRANSPORT,
 	__WGDEVICE_A_LAST
 };
 #define WGDEVICE_A_MAX (__WGDEVICE_A_LAST - 1)
